#ifndef __TAPTEMPOAVERAGE_HPP__             /*-*- indent-tabs-mode:nil;-*-*/
#define __TAPTEMPOAVERAGE_HPP__
/***************************************************************************
 *                                                                         *
 *   InConcert - Tap Tempo Synchronization for Live Perforances            *
 *                                                                         *
 *   Copyright (C) 2008 by Gabriel M. Beddingfield                         *
 *   gabriel@teuton.org                                                    *
 *                                                                         *
 *   "For of him [God], and through him, and unto him, are all things.     *
 *   To him be the glory for ever. Amen." (Romans 11:36)                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; version 2 of the License, or any later  *
 *   version.                                                              *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/* TapTempoAverage.hpp
   Gabriel M. Beddingfield
   2008-02-10

 */

#include "TapTempoInterface.hpp"

// TapTempoAverage
// Tn+1 = Tn + (Tn-T0)/n
class TapTempoAverage : public TapTempoInterface
{
public:
    TapTempoAverage() :
	m_first(0),
	m_count(0)
	{ m_taps_required = 4; }
    virtual usecs_t tap(usecs_t tap_, usecs_t& cycles_per_beat);
    virtual void invalidate(void);
    virtual const char* name(void);

private:
    usecs_t m_first;
    unsigned m_count;
};
    
#endif // __TAPTEMPOAVERAGE_HPP__
