/**********************************************-*- indent-tabs-mode:nil; -*-
 *                                                                         *
 *   InConcert - Tap Tempo Synchronization for Live Perforances            *
 *                                                                         *
 *   Copyright (C) 2008 by Gabriel M. Beddingfield                         *
 *   gabriel@teuton.org                                                    *
 *                                                                         *
 *   "For of him [God], and through him, and unto him, are all things.     *
 *   To him be the glory for ever. Amen." (Romans 11:36)                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; version 2 of the License, or any later  *
 *   version.                                                              *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "TapTempoMedian.hpp"

void TapTempoMedian::invalidate(void)
{
    m_sum = 0;
    m_count = 0;
}

const char* TapTempoMedian::name(void)
{
    return "TapTempoMedian";
}

usecs_t TapTempoMedian::tap(usecs_t tap, usecs_t& cycles_per_tap)
{
    usecs_t rv = 0;
    m_sum += tap;
    ++m_count;
    if(m_count == m_taps_required) {
	usecs_t avg = m_sum/m_count;
        --m_count;
	cycles_per_tap = 2*(tap-avg)/m_count;
	rv = tap + cycles_per_tap;
	m_count = 0;
	m_sum = 0;
    }
    return rv;
}
