#ifndef __TAPTEMPOMEDIAN_HPP__              /*-*- indent-tabs-mode:nil;-*-*/
#define __TAPTEMPOMEDIAN_HPP__
/**********************************************-*- indent-tabs-mode:nil; -*-
 *                                                                         *
 *   InConcert - Tap Tempo Synchronization for Live Perforances            *
 *                                                                         *
 *   Copyright (C) 2008 by Gabriel M. Beddingfield                         *
 *   gabriel@teuton.org                                                    *
 *                                                                         *
 *   "For of him [God], and through him, and unto him, are all things.     *
 *   To him be the glory for ever. Amen." (Romans 11:36)                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; version 2 of the License, or any later  *
 *   version.                                                              *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/* TapTempoMedian.hpp
   Gabriel M. Beddingfield
   2008-02-10

   Tavg = sum(Ti)/n
   Tn+1 = Tn + (Tn-Tavg)/((n-1)/2) = Tn + 2*(Tn-Tavg)/(n-1)
 */

#include "TapTempoInterface.hpp"

class TapTempoMedian : public TapTempoInterface
{
public:
    TapTempoMedian() :
        m_sum(0),
        m_count(0)
        { m_taps_required = 4; }
    virtual ~TapTempoMedian() { }
    virtual usecs_t tap(usecs_t tap_, usecs_t& beats_per_minute);
    virtual const char* name(void);
    virtual void invalidate(void);

private:
    usecs_t m_sum;
    unsigned m_count;
};
    
#endif // __TAPTEMPOMEDIAN_HPP__
